function [ A ] = geta( handles )
% This function returns the aircraft, flight condition and derivative data
% from the GUI. Originally developed by Rees 2003, modified by
% Konstantinos Siliverdis 20-Aug-2004.

switch get(handles.mode,'String');
case 'long' % ----- Longitudinal Variable assignment--------------------
    A(1)  = str2double(get(handles.Mach,    'string'));
    A(2)  = str2double(get(handles.Altitude,'string'));
    A(3)  = str2double(get(handles.gamma,   'string'));
    A(4)  = str2double(get(handles.alpha,   'string'));
    A(5)  = str2double(get(handles.V,       'string'));
    A(6)  = str2double(get(handles.m,       'string'));
    A(7)  = str2double(get(handles.Iy,      'string'));
    A(8)  = str2double(get(handles.rho,     'string'));
    A(9)  = str2double(get(handles.S,       'string'));
    A(10) = str2double(get(handles.c,       'string'));
    A(11) = str2double(get(handles.g,       'string'));
    A(12) = str2double(get(handles.Xu,      'string'));
    A(13) = str2double(get(handles.Xw,      'string'));
    A(14) = str2double(get(handles.Xdw,     'string'));
    A(15) = str2double(get(handles.Xq,      'string'));
    A(16) = str2double(get(handles.Xde,     'string'));
    A(17) = str2double(get(handles.Zu,      'string'));
    A(18) = str2double(get(handles.Zw,      'string'));
    A(19) = str2double(get(handles.Zdw,     'string'));
    A(20) = str2double(get(handles.Zq,      'string'));
    A(21) = str2double(get(handles.Zde,     'string'));
    A(22) = str2double(get(handles.Mu,      'string'));
    A(23) = str2double(get(handles.Mw,      'string'));
    A(24) = str2double(get(handles.Mdw,     'string'));
    A(25) = str2double(get(handles.Mq,      'string'));
    A(26) = str2double(get(handles.Mde,     'string'));
    switch get(handles.DerivativeFormat,    'Value');
    case 1 % Dimensional
        A(27)   =   1;
    case 2 % Normalised
        A(27)   =   2;
    case 3 % Non_Dimensional
        A(27)   =   3;
    end
    switch get(handles.ac_axes,             'Value');
    case 1 % Wind Axes
       A(28)    =   1;
    case 2 % Body Axes
       A(28)    =   2;
    end
    
    
case 'lat' % ----- Lateral-Directional Variable assignment--------------------------------
    A(1)  = str2double(get(handles.Mach,    'string'));
    A(2)  = str2double(get(handles.Altitude,'string'));
    A(3)  = str2double(get(handles.gamma,   'string'));
    A(4)  = str2double(get(handles.alpha,   'string'));
    A(5)  = str2double(get(handles.V,       'string'));
    A(6)  = str2double(get(handles.m,       'string'));
    A(7)  = str2double(get(handles.Ix,      'string'));
    A(8)  = str2double(get(handles.Iz,      'string'));
    A(9)  = str2double(get(handles.Ixy,     'string'));
    A(10) = str2double(get(handles.rho,     'string'));
    A(11) = str2double(get(handles.S,       'string'));
    A(12) = str2double(get(handles.b,       'string'));
    A(13) = str2double(get(handles.g,       'string'));
    A(14) = str2double(get(handles.Yv,      'string'));
    A(15) = str2double(get(handles.Yp,      'string'));
    A(16) = str2double(get(handles.Yr,      'string'));
    A(17) = str2double(get(handles.Yda,     'string'));
    A(18) = str2double(get(handles.Ydr,     'string'));
    A(19) = str2double(get(handles.Lv,      'string'));
    A(20) = str2double(get(handles.Lp,      'string'));
    A(21) = str2double(get(handles.Lr,      'string'));
    A(22) = str2double(get(handles.Lda,     'string'));
    A(23) = str2double(get(handles.Ldr,     'string'));
    A(24) = str2double(get(handles.Nv,      'string'));
    A(25) = str2double(get(handles.Np,      'string'));
    A(26) = str2double(get(handles.Nr,      'string'));
    A(27) = str2double(get(handles.Nda,     'string'));
    A(28) = str2double(get(handles.Ndr,     'string'));
    switch get(handles.DerivativeFormat,    'Value');
    case 1 % Dimensional
        A(29)   =   1;
    case 2 % Normalised
        A(29)   =   2;
    case 3 % Non_Dimensional
        A(29)   =   3;
    end
    switch get(handles.ac_axes,             'Value');
    case 1 % Wind Axes
       A(30)    =   1;
    case 2 % Body Axes
       A(30)    =   2;
    end    
      
end    
return    