function Modechange(handles)
% Because tabs are not an inherent function within Matlab it is necesary to
% simplify them. This is achieved by controlling the visibility property of
% each GUI element. Each GUI element has it's 'userdata' property set to
% LON or LAT or COMMON. This function uses this data to determine which GUI
% elements are visible.
% This function is called to enable the GUI tabs for Longitudinal and
% Lateral/Directional analysis. Depending on the 'mode' this function will
% make say the Lateral/Directional GUI elements invisible and the
% Longitudinal GUI elements visible when the Longitudinal tab is selected.
% And vice versa for the Lateral/Directional tab selection.
% This function remains unchanged from Rees 2003.

H = get(gcf,'Children');

Mode = get(handles.mode,'string');
for i = 1:length(H);
    Userdata = get(H(i), 'Userdata');
    if length(Userdata) == 3;
        switch Mode 
            case 'lat'
                switch Userdata;
                case 'LAT'
                    set(H(i), 'Visible', 'On')
                case 'LON'
                    set(H(i), 'Visible', 'Off')
                end
            case 'long'
                        switch Userdata;
                case 'LAT'
                    set(H(i), 'Visible', 'Off')
                case 'LON'
                    set(H(i), 'Visible', 'On')
                end
        end
    end
%set(handles.filename,'String','');            
end
return