function ResetData(handles)
% This function will reset all flight condition and derivative parameters to blank.
% By Konstantinos Siliverdis 20-Aug-2004 

%   Reset Common data
    set(handles.Mach,       'String', '','Value',0) ;
    set(handles.Altitude,   'String', '','Value',0) ;
    set(handles.gamma,      'String', '','Value',0) ;
    set(handles.alpha,      'String', '','Value',0) ;
    set(handles.V,          'String', '','Value',0) ;
    set(handles.m,          'String', '','Value',0) ;
    set(handles.rho,        'String', '','Value',0) ;
    set(handles.S,          'String', '','Value',0) ;
    set(handles.g,          'String', '','Value',0) ;
%   Reset Longitudinal data
    set(handles.Iy,         'String', '','Value',0) ;
    set(handles.c,          'String', '','Value',0) ;
    
    set(handles.Xu,         'String', '','Value',0) ;
    set(handles.Xw,         'String', '','Value',0) ;
    set(handles.Xdw,        'String', '','Value',0) ;
    set(handles.Xq,         'String', '','Value',0) ;
    set(handles.Xde,        'String', '','Value',0) ;
    
    set(handles.Zu,         'String', '','Value',0) ;
    set(handles.Zw,         'String', '','Value',0) ;
    set(handles.Zdw,        'String', '','Value',0) ;
    set(handles.Zq,         'String', '','Value',0) ;
    set(handles.Zde,        'String', '','Value',0) ;
    
    set(handles.Mu,         'String', '','Value',0) ;
    set(handles.Mw,         'String', '','Value',0) ;
    set(handles.Mdw,        'String', '','Value',0) ;
    set(handles.Mq,         'String', '','Value',0) ;
    set(handles.Mde,        'String', '','Value',0) ;
    
%   Reset Lateral/Directional data
    set(handles.Ix,         'String', '','Value',0) ;
    set(handles.Iz,         'String', '','Value',0) ;
    set(handles.Ixy,        'String', '','Value',0) ;
    set(handles.b,          'String', '','Value',0) ;
    
    set(handles.Yv,         'String', '','Value',0) ;
    set(handles.Yp,         'String', '','Value',0) ;
    set(handles.Yr,         'String', '','Value',0) ;
    set(handles.Yda,        'String', '','Value',0) ;
    set(handles.Ydr,        'String', '','Value',0) ;    
    
    set(handles.Lv,         'String', '','Value',0) ;
    set(handles.Lp,         'String', '','Value',0) ;
    set(handles.Lr,         'String', '','Value',0) ;
    set(handles.Lda,        'String', '','Value',0) ;
    set(handles.Ldr,        'String', '','Value',0) ;    
    
    set(handles.Nv,         'String', '','Value',0) ;
    set(handles.Np,         'String', '','Value',0) ;
    set(handles.Nr,         'String', '','Value',0) ;
    set(handles.Nda,        'String', '','Value',0) ;
    set(handles.Ndr,        'String', '','Value',0) ;    
    
    % Reset Derivative Format to Dimensional
    set(handles.DerivativeFormat,'Value', 1) ;    
    % Reset Model Order to Full Order
    set(handles.ModelOrder,'Value', 1) ;
    % Reset Filename
    set(handles.filename,'String','');
    % Reset Aircraft Axes to Wind 
    set(handles.ac_axes,'value',1);
    % Reset Basic Aircraft Stability modes
    set(handles.Wn,'string','');
    set(handles.Z,'string','');
    %Reset input signal options
    set(handles.inputsignal,'value',1)
    set(handles.pushbutton41,'position',[0.028 0.344 0.128 0.162]);
    set(handles.widthlable,'Visible','off')
    set(handles.width,'Visible','off')
    set(handles.omegalable,'Visible','off')
    set(handles.omega,'Visible','off')
    %Deactivate Stability and Handling Qualities buttons
    set(handles.stab_cont,'enable','off')
    %set(handles.hand_qual,'enable','off') MVC
    set(handles.oug,'visible','off')
    return