function [ PolyString ] = vec2poly( Vector )
% This function converts a vector to the string of the equivalent
% polynomial expression
% eg: convert a vector {[1 3 5]} to a Tex string "(s^2 + 3s + 5)" 
% This function is called by the XferFn2Plot.m
% It is used unchanged from Rees 2003.

% trim leading zeros
precision = 3;
PolyString = '';
TempString = '';
[w,z] = damp(tf(1,Vector));
VectorLength = length(w);
x = 1;
while x <= VectorLength
    switch abs(z(x))
        case 1 % this is a real root
            if sign(z(x))<0
                rootsign = ' - ';
            else
                rootsign = ' + ';
            end
            rootvalue = num2str(w(x),precision);
            if rootvalue == '0'
                TempString = ' s ';
            else
                TempString = strcat('(s ',rootsign,rootvalue,')');
            end
            x=x+1;
        otherwise %this is a complex pair
            if sign(z(x))<0
                rootsign = ' - ';
            else
                rootsign = ' + ';
            end
            root1value = num2str(2*abs(w(x))*abs(z(x)),precision);
            root2value = num2str(w(x)^2,precision);
            TempString = strcat('(s^2 ',rootsign,root1value,'s +',root2value,')');
           x=x+2;
    end %switch
    PolyString = strcat(PolyString,TempString);
end %while
