function XferFn2Plot( handles,NUM,DEN,Limits )

% This function writes the transfer function on the time history plot
% Used unchanged from Rees 2003.

% If the transfer function toggle button is off - exit
if get(handles.xfercheck,'Value') ==   0
    return
end
Limits = axis;
yrange = (Limits(4)-Limits(3));
xrange = (Limits(2)-Limits(1));
ypos = (Limits(4)-yrange*.21);
xpos = (Limits(1)+Limits(2))/2;

[z,p,k] = zpkdata(tf(NUM,DEN),'v');
gain = num2str(k,4);
num  = strcat(gain,Vec2Poly(NUM));
den  = vec2poly(DEN);

tempstr = '';
for  i = 1:round(length(den)*.81)
    tempstr = strcat(tempstr,'\_');
end
text(xpos,ypos,den,'Color',[0,0,0],...
    'BackgroundColor',[1,1,1],...
    'VerticalAlignment','top',...
    'HorizontalAlignment','center',...
    'FontSize',8);
text(xpos,ypos,num,'Color',[0,0,0],...
    'BackgroundColor',[1,1,1],...
    'VerticalAlignment','bottom',...
    'HorizontalAlignment','center',...
    'FontSize',8);
text(xpos,ypos,tempstr,'Color',[0,0,0],...
    'VerticalAlignment','baseline',...
    'HorizontalAlignment','center',...
    'FontSize',8);
return