function varargout = ac_dynamics(varargin)
% This figure presents the basic or augmented aircraft dynamics according
% to the presence or not of an actuator and feedback gain(s). The structure
% of the state space matrices is the one that can be found in Theory (see Cook) 
% and not the one that Matlab uses to calculate state space representations
% of series and feedback systems (see SERIES, FEEDBACK).
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Last Modified by Konstantinos Siliverdis 20-Aug-2004 15:21:21

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ac_dynamics_OpeningFcn, ...
                   'gui_OutputFcn',  @ac_dynamics_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ac_dynamics is made visible.
function ac_dynamics_OpeningFcn(hObject, eventdata, handles, varargin)

acdyn=getappdata(0,'ACDYN');
A=acdyn{1};
B=acdyn{2};
set(handles.mode,'string',acdyn{6});
modechange(handles);
hone=findobj(gcf,'userdata',0);
htwo=findobj(gcf,'userdata',1);
hthree=findobj(gcf,'userdata',2);
if strcmp(acdyn{6},'long')
    gainslong=[acdyn{9} acdyn{10} acdyn{11} acdyn{12}];
    actNUM=acdyn{7};,actDEN=acdyn{8};
elseif strcmp(acdyn{6},'lat') & acdyn{5}==1 %Lateral
    set(handles.ksi,'visible','on'),set(handles.zeta,'visible','off')
    gainslat=[acdyn{11} acdyn{12} acdyn{13} acdyn{14}];
    AactNUM=acdyn{7};,AactDEN=acdyn{8};
elseif strcmp(acdyn{6},'lat') & acdyn{5}==2 %Directional
    set(handles.ksi,'visible','off'),set(handles.zeta,'visible','on')
    gainsdir=[acdyn{15} acdyn{16} acdyn{17} acdyn{18}];
    RactNUM=acdyn{9};,RactDEN=acdyn{10};
end
if ~isappdata(0,'STATUS')
    hdist=get(findobj(hObject),'position'); % lines 56-65 : Change position to objects to fit the matrix dimensions
    for i=1:length(hdist)
        k(i,1:4)=hdist{i};
    end
    index=find(k(:,1)>75.5);
    kin=k(index,:);
    for i=1:length(index)
        set(findobj(hObject,'position',hdist{index(i)}),'position',...
            [k(index(i),1)-19.2 k(index(i),2) k(index(i),3) k(index(i),4)]);
    end
    set(handles.text127,'visible','off'),set(handles.text128,'visible','off')
    set(hone,'visible','on')
	set(htwo,'visible','off')
	set(hthree,'visible','off')
	format long
    hedit=findobj(hObject,'style','edit','visible','on'); %This process (76 - 80) reduces the 'set' lines!!
    a=get(hedit,'tag');a=sort(a);,Ares=A';,Ares=reshape(Ares,[16,1]);%,keyboard
    for i=1:16
        set(findobj(hedit,'tag',a{i}),'string',num2str(Ares(i)))
    end

    if strcmp(acdyn{6},'long') | (strcmp(acdyn{6},'lat') & acdyn{5}==1) 
        set(handles.B11,'string',num2str(B(1,1)))
        set(handles.B21,'string',num2str(B(2,1)))
        set(handles.B31,'string',num2str(B(3,1)))
        set(handles.B41,'string',num2str(B(4,1)))
    elseif strcmp(acdyn{6},'lat') & acdyn{5}==2
        set(handles.B11,'string',num2str(B(1,2)))
        set(handles.B21,'string',num2str(B(2,2)))
        set(handles.B31,'string',num2str(B(3,2)))
        set(handles.B41,'string',num2str(B(4,2)))
    end
   
elseif isappdata(0,'STATUS')
    set(handles.text66,'visible','off'),set(handles.text67,'visible','off')
    if (length(acdyn{8})==1 & (strcmp(acdyn{6},'long') | (strcmp(acdyn{6},'lat') & acdyn{5}==1))) | (strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==1)
        hdist=get(findobj(hObject),'position'); % lines 91-100 : Change position to objects to fit the matrix dimensions
        for i=1:length(hdist)
            k(i,1:4)=hdist{i};
        end
        index=find(k(:,1)>75.5);
        kin=k(index,:);
        for i=1:length(index)
            set(findobj(hObject,'position',hdist{index(i)}),'position',...
                [k(index(i),1)-19.2 k(index(i),2) k(index(i),3) k(index(i),4)]);
        end
        set(hone,'visible','on')
	    set(htwo,'visible','off')
	    set(hthree,'visible','off')
        if strcmp(acdyn{6},'long') & length(acdyn{8})==1
            set(handles.text127,'visible','on'),set(handles.text128,'visible','off')
            Baug=B;
            Aaug=A-B*gainslong;
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==1 & length(acdyn{8})==1
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on')
            Aaug=A-B(:,1)*gainslat;
            Baug=B(:,1);
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==1
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on')
            Aaug=A-B(:,2)*gainsdir;
            Baug=B(:,2);
        end
       hedit=findobj(hObject,'style','edit','visible','on'); 
       a=get(hedit,'tag');a=sort(a);,Ares=Aaug';,Ares=reshape(Ares,[16,1]);,AB=[Ares;Baug];%,keyboard
       for i=1:20
           set(findobj(hedit,'tag',a{i}),'string',num2str(AB(i)))
       end
                    
	elseif (length(acdyn{8})==2 & (strcmp(acdyn{6},'long') | (strcmp(acdyn{6},'lat') & acdyn{5}==1))) | (strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==2) %1st order actuator dynamics
        hdist=get(findobj(hObject),'position'); % lines 121-130 : Change position to objects to fit the matrix dimensions
        for i=1:length(hdist)
            k(i,1:4)=hdist{i};
        end
        index=find(k(:,1)>75.5);
        kin=k(index,:);
        for i=1:length(index)
            set(findobj(hObject,'position',hdist{index(i)}),'position',...
                [k(index(i),1)-10 k(index(i),2) k(index(i),3) k(index(i),4)]);
        end        
        set(hone,'visible','off')
        set(findobj(hone,'style','edit'),'visible','on')
        set(htwo,'visible','on')
        set(hthree,'visible','off')
        if strcmp(acdyn{6},'long') & length(acdyn{8})==2
            set(handles.text127,'visible','on'),set(handles.text128,'visible','off')
            set(handles.etafc1,'visible','on')
            set(handles.zetafc1,'visible','off')
	        set(handles.ksifc1,'visible','off')
            Baug=[zeros(4,1);actNUM/actDEN(1)];
            Aaug=[         A                             B;
                  -actNUM/actDEN(1)*gainslong   -actDEN(2)/actDEN(1)];
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==1 & length(acdyn{8})==2
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on')
            set(handles.etafc1,'visible','off')
            set(handles.zetafc1,'visible','off')
	        set(handles.ksifc1,'visible','on')
            Baug=[zeros(4,1);AactNUM/AactDEN(1)];
            Aaug=[         A                            B(:,1);
                  -AactNUM/AactDEN(1)*gainslat   -AactDEN(2)/AactDEN(1)]
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==2
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on')
            set(handles.etafc1,'visible','off')
            set(handles.zetafc1,'visible','on')
	        set(handles.ksifc1,'visible','off')
            Baug=[zeros(4,1);RactNUM/RactDEN(1)];%,keyboard
            Aaug=[         A                             B(:,2);
                  -RactNUM/RactDEN(1)*gainsdir   -RactDEN(2)/RactDEN(1)];
        end
        hedit=findobj(hObject,'style','edit','visible','on'); 
        a=get(hedit,'tag');a=sort(a);,Ares=Aaug';,Ares=reshape(Ares,[25,1]);,AB=[Ares;Baug];%,keyboard
        for i=1:30
           set(findobj(hedit,'tag',a{i}),'string',num2str(AB(i)))
        end
        
    elseif (length(acdyn{8})==3 & (strcmp(acdyn{6},'long') | (strcmp(acdyn{6},'lat') & acdyn{5}==1))) | (strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==3)%2nd order actuator dynamics
        set(hone,'visible','off')
        set(findobj(hone,'style','edit'),'visible','on')
        set(htwo,'visible','off')
        set(findobj(htwo,'style','edit'),'visible','on')
        set(hthree,'visible','on')
        set(handles.text1,'visible','on')
        if strcmp(acdyn{6},'long') & length(acdyn{8})==3
            set(handles.text127,'visible','on'),set(handles.text128,'visible','off')
            set(handles.etafc1,'visible','on')
            set(handles.zetafc1,'visible','off')
	        set(handles.ksifc1,'visible','off')
            set(handles.etafc2,'visible','on')
            set(handles.zetafc2,'visible','off')
	        set(handles.ksifc2,'visible','off')
            Baug=[zeros(4,1);0;actNUM/actDEN(1)];
            Aaug=[      A                  B                zeros(4,1);
                   zeros(1,4)              0                    1;
            actNUM/actDEN(1)*gainslong -actDEN(3)/actDEN(1) -actDEN(2)/actDEN(1)];%,keyboard
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==1 & length(acdyn{8})==3
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on')
            set(handles.etafc1,'visible','off')
            set(handles.zetafc1,'visible','off')
	        set(handles.ksifc1,'visible','on')
            set(handles.etafc2,'visible','off')
            set(handles.zetafc2,'visible','off')
	        set(handles.ksifc2,'visible','on')
            Baug=[zeros(4,1);0;AactNUM/AactDEN(1)];
            Aaug=[       A                       B(:,1)                 zeros(4,1);
                    zeros(1,4)                     0                        1;
              AactNUM/AactDEN(1)*gainslat      -AactDEN(3)/AactDEN(1)   -AactDEN(2)/AactDEN(1)];
        elseif strcmp(acdyn{6},'lat') & acdyn{5}==2 & length(acdyn{10})==3
            set(handles.text127,'visible','off'),set(handles.text128,'visible','on'),set(handles.etafc1,'visible','off')
            set(handles.zetafc1,'visible','on')
	        set(handles.ksifc1,'visible','off')
            set(handles.etafc2,'visible','off')
            set(handles.zetafc2,'visible','on')
	        set(handles.ksifc2,'visible','off')
            Baug=[zeros(4,1);0;RactNUM/RactDEN(1)];%,keyboard
            Aaug=[        A                      B(:,2)                zeros(4,1);
                     zeros(1,4)                    0                        1;
            RactNUM/RactDEN(1)*gainsdir      -RactDEN(3)/RactDEN(1)   -RactDEN(2)/RactDEN(1)];
        end
        
        hedit=findobj(hObject,'style','edit','visible','on'); 
        a=get(hedit,'tag');a=sort(a);,Ares=Aaug';,Ares=reshape(Ares,[36,1]);,AB=[Ares;Baug];%,keyboard
        for i=1:42
           set(findobj(hedit,'tag',a{i}),'string',num2str(AB(i)))
        end
        
	end
end
format
if ~isappdata(0,'STATUS')
   rmappdata(0,'ACDYN')
end


% Choose default command line output for ac_dynamics
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes ac_dynamics wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ac_dynamics_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;



