function Adald=dal2dless(A)

% Dimensional to Dimensionless Derivative conversion
% By Konstantinos Siliverdis 20-Aug-2004



if length(A)==28 %longitudinal
    
Adald(1:11)=A(1:11);
Adald(27:28)=A(27:28);  
Adald(12)=A(12)/(0.5*A(8)*A(5)*A(9));              % Xu / (1/2 * rho * V   *  S)
Adald(13)=A(13)/(0.5*A(8)*A(5)*A(9));              % Xw / (1/2 * rho * V   *  S)
Adald(14)=A(14)/(0.5*A(8)*A(9)*A(10));             % Xdw/ (1/2 * rho       *  S * c)
Adald(15)=A(15)/(0.5*A(8)*A(5)*A(9)*A(10));        % Xq / (1/2 * rho * V   *  S * c)
Adald(16)=A(16)/(0.5*A(8)*A(5)*A(5)*A(9));         % Xde/ (1/2 * rho * V^2 *  S)
Adald(17)=A(17)/(0.5*A(8)*A(5)*A(9));              % Zu / (1/2 * rho * V   *  S)
Adald(18)=A(18)/(0.5*A(8)*A(5)*A(9));              % Zw / (1/2 * rho * V   *  S)
Adald(19)=A(19)/(0.5*A(8)*A(9)*A(10));             % Zdw/ (1/2 * rho       *  S * c)
Adald(20)=A(20)/(0.5*A(8)*A(5)*A(9)*A(10));        % Zq / (1/2 * rho * V   *  S * c)
Adald(21)=A(21)/(0.5*A(8)*A(5)*A(5)*A(9));         % Zde/ (1/2 * rho * V^2 *  S)
Adald(22)=A(22)/(0.5*A(8)*A(5)*A(9)*A(10));        % Mu / (1/2 * rho * V   *  S * c)
Adald(23)=A(23)/(0.5*A(8)*A(5)*A(9)*A(10));        % Mw / (1/2 * rho * V   *  S * c)
Adald(24)=A(24)/(0.5*A(8)*A(9)*A(10)*A(10));       % Mdw/ (1/2 * rho       *  S * c^2)
Adald(25)=A(25)/(0.5*A(8)*A(5)*A(9)*A(10)*A(10));  % Mq / (1/2 * rho * V   *  S * c^2)
Adald(26)=A(26)/(0.5*A(8)*A(5)*A(5)*A(9)*A(10));   % Mde/ (1/2 * rho * V^2 *  S * c)

elseif length(A)==30 %Lateral
    
Adald(1:13)=A(1:13);
Adald(29:30)=A(29:30);
Adald(14)=A(14)/(0.5*A(10)*A(5)*A(11));            %Yv / (1/2 * rho * V   * S)
Adald(15)=A(15)/(0.5*A(10)*A(5)*A(11)*A(12));      %Yp / (1/2 * rho * V   * S * b)
Adald(16)=A(16)/(0.5*A(10)*A(5)*A(11)*A(12));      %Yr / (1/2 * rho * V   * S * b)
Adald(17)=A(17)/(0.5*A(10)*A(5)*A(5)*A(11));       %Yda/ (1/2 * rho * V^2 * S)
Adald(18)=A(18)/(0.5*A(10)*A(5)*A(5)*A(11));       %Ydr/ (1/2 * rho * V^2 * S)
Adald(19)=A(19)/(0.5*A(10)*A(5)*A(11)*A(12));      %Lv / (1/2 * rho * V   * S * b)
Adald(20)=A(20)/(0.5*A(10)*A(5)*A(11)*A(12)*A(12));%Lp / (1/2 * rho * V   * S * b^2)
Adald(21)=A(21)/(0.5*A(10)*A(5)*A(11)*A(12)*A(12));%Lr / (1/2 * rho * V   * S * b^2)
Adald(22)=A(22)/(0.5*A(10)*A(5)*A(5)*A(11)*A(12)); %Lda/ (1/2 * rho * V^2 * S * b)
Adald(23)=A(23)/(0.5*A(10)*A(5)*A(5)*A(11)*A(12)); %Ldr/ (1/2 * rho * V^2 * S * b)
Adald(24)=A(24)/(0.5*A(10)*A(5)*A(11)*A(12));      %Nv / (1/2 * rho * V   * S * b)
Adald(25)=A(25)/(0.5*A(10)*A(5)*A(11)*A(12)*A(12));%Np / (1/2 * rho * V   * S * b^2)
Adald(26)=A(26)/(0.5*A(10)*A(5)*A(11)*A(12)*A(12));%Nr / (1/2 * rho * V   * S * b^2)
Adald(27)=A(27)/(0.5*A(10)*A(5)*A(5)*A(11)*A(12)); %Nda/ (1/2 * rho * V^2 * S * b)
Adald(28)=A(28)/(0.5*A(10)*A(5)*A(5)*A(11)*A(12)); %Ndr/ (1/2 * rho * V^2 * S * b)

else
    msgbox('Data is incomplete or invalid. Please check for empty fields','Error in input data','error','modal')
end
