function Addal=dless2dal(A)

% Dimensionless to Dimansional Derivative conversion
% By Konstantinos Siliverdis 20-Aug-2004

%A=geta(handles);

if length(A)==28 %longitudinal
    
Addal(1:11)=A(1:11);
Addal(27:28)=A(27:28);  
Addal(12)=A(12)*0.5*A(8)*A(5)*A(9);              % Xu * 1/2 * rho * V   *  S
Addal(13)=A(13)*0.5*A(8)*A(5)*A(9);              % Xw * 1/2 * rho * V   *  S
Addal(14)=A(14)*0.5*A(8)*A(9)*A(10);             % Xdw* 1/2 * rho       *  S * c
Addal(15)=A(15)*0.5*A(8)*A(5)*A(9)*A(10);        % Xq * 1/2 * rho * V   *  S * c
Addal(16)=A(16)*0.5*A(8)*A(5)*A(5)*A(9);         % Xde* 1/2 * rho * V^2 *  S
Addal(17)=A(17)*0.5*A(8)*A(5)*A(9);              % Zu * 1/2 * rho * V   *  S 
Addal(18)=A(18)*0.5*A(8)*A(5)*A(9);              % Zw * 1/2 * rho * V   *  S
Addal(19)=A(19)*0.5*A(8)*A(9)*A(10);             % Zdw* 1/2 * rho       *  S * c
Addal(20)=A(20)*0.5*A(8)*A(5)*A(9)*A(10);        % Zq * 1/2 * rho * V   *  S * c
Addal(21)=A(21)*0.5*A(8)*A(5)*A(5)*A(9);         % Zde* 1/2 * rho * V^2 *  S
Addal(22)=A(22)*0.5*A(8)*A(5)*A(9)*A(10);        % Mu * 1/2 * rho * V   *  S * c
Addal(23)=A(23)*0.5*A(8)*A(5)*A(9)*A(10);        % Mw * 1/2 * rho * V   *  S * c
Addal(24)=A(24)*0.5*A(8)*A(9)*A(10)*A(10);       % Mdw* 1/2 * rho       *  S * c^2
Addal(25)=A(25)*0.5*A(8)*A(5)*A(9)*A(10)*A(10);  % Mq * 1/2 * rho * V   *  S * c^2
Addal(26)=A(26)*0.5*A(8)*A(5)*A(5)*A(9)*A(10);   % Mde* 1/2 * rho * V^2 *  S * c

elseif length(A)==30 %lateral
    
Addal(1:13)=A(1:13);
Addal(29:30)=A(29:30); 
Addal(14)=A(14)*0.5*A(10)*A(5)*A(11);            %Yv * 1/2 * rho * V   * S
Addal(15)=A(15)*0.5*A(10)*A(5)*A(11)*A(12);      %Yp * 1/2 * rho * V   * S * b
Addal(16)=A(16)*0.5*A(10)*A(5)*A(11)*A(12);      %Yr * 1/2 * rho * V   * S * b
Addal(17)=A(17)*0.5*A(10)*A(5)*A(5)*A(11);       %Yda* 1/2 * rho * V^2 * S
Addal(18)=A(18)*0.5*A(10)*A(5)*A(5)*A(11);       %Ydr* 1/2 * rho * V^2 * S
Addal(19)=A(19)*0.5*A(10)*A(5)*A(11)*A(12);      %Lv * 1/2 * rho * V   * S * b
Addal(20)=A(20)*0.5*A(10)*A(5)*A(11)*A(12)*A(12);%Lp * 1/2 * rho * V   * S * b^2
Addal(21)=A(21)*0.5*A(10)*A(5)*A(11)*A(12)*A(12);%Lr * 1/2 * rho * V   * S * b^2
Addal(22)=A(22)*0.5*A(10)*A(5)*A(5)*A(11)*A(12); %Lda* 1/2 * rho * V^2 * S * b
Addal(23)=A(23)*0.5*A(10)*A(5)*A(5)*A(11)*A(12); %Ldr* 1/2 * rho * V^2 * S * b
Addal(24)=A(24)*0.5*A(10)*A(5)*A(11)*A(12);      %Nv * 1/2 * rho * V   * S * b
Addal(25)=A(25)*0.5*A(10)*A(5)*A(11)*A(12)*A(12);%Np * 1/2 * rho * V   * S * b^2
Addal(26)=A(26)*0.5*A(10)*A(5)*A(11)*A(12)*A(12);%Nr * 1/2 * rho * V   * S * b^2
Addal(27)=A(27)*0.5*A(10)*A(5)*A(5)*A(11)*A(12); %Nda* 1/2 * rho * V^2 * S * b
Addal(28)=A(28)*0.5*A(10)*A(5)*A(5)*A(11)*A(12); %Ndr* 1/2 * rho * V^2 * S * b

else
    msgbox('Data is incomplete or invalid. Please check for empty fields','Error in input data','error','modal')
end
