function varargout = fdacad3(varargin)
% FDACAD3 M-file for fdacad3.fig
%      FDACAD3, by itself, creates a new FDACAD3 or raises the existing
%      singleton*.
%
%      ALTITUDE = FDACAD3 returns the handle to a new FDACAD3 or the handle to
%      the existing singleton*.
%
%      FDACAD3('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FDACAD3.M with the given input arguments.
%
%      FDACAD3('Property','Value',...) creates a new FDACAD3 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fdacad3_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fdacad3_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%      See also: GUIDE, GUIDATA, GUIHANDLES
%
%      FDA-CAD version 3.01
%      THIS FUNCTION CONTROLS THE OPENING TITLE SCREEN
%           AND BASIC AIRCRAFT ANALYSIS SCREEN
%
% Original file by Konstantinos Siliverdis - 2004
% Last Modified by GUIDE v2.5 21-Mar-2013 10:06:43
% Modifications by Michael Cook - 2013
%
% Begin initialization code - DO NOT EDIT

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fdacad3_OpeningFcn, ...
                   'gui_OutputFcn',  @fdacad3_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
                            
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end
if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
    
end
% End initialization code - DO NOT EDIT

% --- Executes just before fdacad3 opening screen is made visible.
function fdacad3_OpeningFcn(hObject, eventdata, handles, varargin)
if isappdata(0,'TRANS')
rmappdata(0,'ATRANS');
end

%Modifications to change opening imagery. (M.V.Cook Jan 2013)
% Loads copyright protected image of Eurofighter Typhoon - Courtesy BAE Systems.
set(handles.image,'Cdata',imread('Flash7a.bmp'));
movegui(handles.fdacad3,'north'); % Centres image on computer screen.
%End of imagery modification

% ============Start opening screen=================
if ~isappdata(0,'BACKSCREEN')
set(handles.image,'position',[0 0 1 1]); 
set(handles.ModelOrder,'visible','off')
set(handles.fullord_lat,'visible','off')
set(handles.DerivativeFormat,'visible','off')
set(handles.ac_axes,'visible','off')
set(handles.inputsignal,'visible','off')
set(handles.init_lat,'visible','on')
set(handles.init_long,'visible','on')
set(handles.model_menu,'visible','off')
set(handles.abt,'visible','on')
set(handles.oug,'visible','on')
set(handles.closedown,'visible','off')
else
set(handles.image,'visible','off')
set(handles.init_long,'visible','off')
set(handles.init_lat,'visible','off')
set(handles.abt,'visible','off')


% =========================================================================
%This section enables full or reduced order calculation for basic aircraft
%Longitudinal analysis - on Model Order menu selection.
%Or, sets full order only for basic aircraft Lat-Dir analysis.
if strcmp(get(handles.mode,'string'),'lat')
set(handles.fullord_lat,'visible','on')
set(handles.ModelOrder,'visible','off')
else
set(handles.fullord_lat,'visible','off')
set(handles.ModelOrder,'visible','on')    
end
set(handles.DerivativeFormat,'visible','on')
set(handles.ac_axes,'visible','on')
set(handles.inputsignal,'visible','on')
    
end
% =========================================================================

%=========Derivative Conversion Visibility=================================
H=get(gcf,'children');
for i=1:length(H);
    userdata=get(H(i),'userdata');
    if length(userdata)==7;
        set(H(i),'visible','off');
    end
end
%==========================================================================

%=========Input Signal Properties set=============
set(handles.pushbutton41,'position',[0.028 0.344 0.128 0.162]);
set(handles.widthlable,'Visible','off')
set(handles.width,'Visible','off')
set(handles.omegalable,'Visible','off')
set(handles.omega,'Visible','off')
%=================================================

% Choose default command line output for fdacad3
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = fdacad3_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

%==== SET UP OPTIONS FOR LONGITUDINAL ANALYSIS SCREEN =====================
function init_long_Callback(hObject, eventdata, handles)
set(handles.image,'visible','off')
set(handles.init_long,'visible','off')
set(handles.init_lat,'visible','off')
set(handles.ModelOrder,'visible','on','enable','on')
set(handles.fullord_lat,'visible','off')
set(handles.DerivativeFormat,'visible','on')
set(handles.ac_axes,'visible','on')
set(handles.inputsignal,'visible','on')
set(handles.mode,'string','long')
set(handles.pushbutton83,'visible','on')
set(handles.stab_cont,'enable','off')
set(handles.model_menu,'visible','on')
set(handles.abt,'visible','off')
set(handles.oug,'visible','off')
set(handles.closedown,'visible','on')
movegui(handles.fdacad3,'north'); 
ResetData(handles)
ModeChange(handles)
Units(handles,'on')

%===== SET UP OPTIONS FOR LATERAL-DIRECTIONAL ANALYSIS SCREEN =============
function init_lat_Callback(hObject, eventdata, handles)
set(handles.image,'visible','off')
set(handles.init_long,'visible','off')
set(handles.init_lat,'visible','off')
set(handles.fullord_lat,'visible','on','enable','inactive')
set(handles.ModelOrder,'visible','off')% MVC
set(handles.DerivativeFormat,'visible','on')
set(handles.ac_axes,'visible','on')
set(handles.inputsignal,'visible','on')
set(handles.mode,'string','lat')
set(handles.pushbutton83,'visible','on')
set(handles.stab_cont,'enable','off')
set(handles.model_menu,'visible','on')
set(handles.abt,'visible','off')
set(handles.oug,'visible','off')
set(handles.closedown,'visible','on')
movegui(handles.fdacad3,'north'); 
ResetData(handles)
ModeChange(handles)
Units(handles,'on')

% ====== DATA ENTRY ERROR MESSAGE =========================================
% ----- Returns an error if the entry is not a valid number ---------------
% ----- Each numeric field uses this callback -----------------------------
function varargout = valid_Callback(h, eventdata, handles, varargin)
val = str2double(get(h,'string'));
if isnan(val)
    errordlg('You must enter a numeric value','Invalid Input','modal')
else
    set(h, 'value', val) 
end
% ====== End of error message =============================================

% === START SOLUTION OF EQUATIONS OF MOTION COMPUTATION ===================
% --- Executes on button press in RUN MODEL.
function run_model_Callback(hObject, eventdata, handles)

mo=get(handles.ModelOrder,'value');
setappdata(0,'mo',get(handles.ModelOrder,'Value'))

A=getA(handles);
if isnan(A)
    errordlg('Aircraft data is incomplete or invalid.','Invalid Data','modal'),        
    clc
end
if get(handles.ac_axes,'value')==1 & A(4)~=0 & ~isnan(A)
       option=questdlg(sprintf('In Wind Axes Notation, the Body Incidence must be set to zero.\nSelect Cancel to go back and correct.'),...
        'Warning','Continue','Cancel','Cancel');
       if strcmp(option,'Continue')
           set(handles.stab_cont,'enable','on')
           switch get(handles.mode,'string')
               case 'long'
                   switch mo;
                       case 1 
                           [NUM,DEN,A,B,C,D] = Longsolve (handles);
                           set(handles.u_lon_ch,'enable','on'); 
                       case 2 
                           [NUM,DEN, A, B, C, D] = ShortSolve(handles); 
                   end
               case 'lat'
                   [NUMA, NUMR, DENA, A,B,C,D]=latsolve(handles);
           end
       else
       end
else
    switch get(handles.mode,'string')
               case 'long'
                   mo=get(handles.ModelOrder,'value')
                   if isnan(A)
                       set(handles.stab_cont,'enable','off')
                   elseif ~isnan(A)
                       switch mo;
                           case 1 
                               set(handles.stab_cont,'enable','on')
                               [NUM,DEN,A,B,C,D] = Longsolve (handles);
                           case 2 
                               set(handles.stab_cont,'enable','off')
                               [NUM,DEN, A, B, C, D] = ShortSolve(handles);
                       end
                   end
               case 'lat'
                   if isnan(A)
                       set(handles.stab_cont,'enable','off')
                   elseif ~isnan(A)
                       set(handles.stab_cont,'enable','on')
                       [NUMA, NUMR, DENA, A,B,C,D]=latsolve(handles);
                   end
    end  
end

clc 

% === END OF SOLUTION COMPUTATION =========================================

% == RESET AIRCRAFT INPUT DATA TO ZERO BEFORE ENTERING NEW AIRCRAFT DATA ==          
%--- Executes on "Reset" button press.
function reset_Callback(hObject, eventdata, handles)
ResetData(handles)
% ===== End of reset ======================================================

% ===== SELECT INPUT SIGNAL ===============================================
% --- Executes on selection change in "Inputsignal".
function inputsignal_Callback(hObject, eventdata, handles)

switch get(handles.inputsignal,'Value')
    case 1  % Step
        set(handles.pushbutton41,'position',[0.028 0.344 0.128 0.162]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 2  % Impulse
        set(handles.pushbutton41,'position',[0.028 0.344 0.128 0.162]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 3  % Pulse
        set(handles.pushbutton41,'position',[0.028 0.297 0.128 0.208]);
        set(handles.widthlable,'Visible','on')
        set(handles.width,'Visible','on')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 4  % Ramp
        set(handles.pushbutton41,'position',[0.028 0.344 0.128 0.162]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 5  % Sine wave
        set(handles.pushbutton41,'position',[0.028 0.297 0.128 0.208]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','on')
        set(handles.omega,'Visible','on')
    case 6  % Doublet
        set(handles.pushbutton41,'position',[0.028 0.297 0.128 0.208]);
        set(handles.widthlable,'Visible','on')
        set(handles.width,'Visible','on')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')        
end
% ======== End of input signal selection ==================================

% ========= ENABLE DERIVATIVE CONVERSION COMPUTATION ======================
% ========= Derivative Conversion button press ============================
% Care to set body incidence to the value required for the conversion
% selected - this may conflict with the value required to run the model 
function conversion_Callback(hObject, eventdata, handles)

H=get(gcf,'children');
for i=1:length(H);
    userdata=get(H(i),'userdata');
    if length(userdata)==7;
        set(H(i),'visible','on');
    elseif length(userdata)<=6
        set(H(i),'enable','off');
    end
end

acform=get(handles.DerivativeFormat,'value');
if acform==1,
    acf='Dimensional';
elseif acform==2,
    acf='Normalised (USA)';
elseif acform==3,
    acf='Dimensionless (UK)';
end
acax=get(handles.ac_axes,'value');
if acax==1,
    acx='Wind Axes';
elseif acax==2,
    acx='Body Axes';
end
set(handles.conv_text,'string',sprintf('From %s, %s to:',acf,acx));
% ========== End of derivative conversion =================================

% ========== BASIC AIRCRAFT RESPONSE BODE PLOTS COMPUTATION ===============
% ----- Select input-output choice on output variable check buttons -------
% NOTE:- All TF's are set to positive gain before calculating Bode plot.
%Non-zero zero frequency phase is due to non-minimum zeros only. 

% ----- LONGITUDINAL BODE PLOTS USING LTIVIEW -----------------------------
    
function varargout = u_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSu = tf(NUM(1,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);% Not relevant - MVC
end
    ltiview('bode',SYSu);
%end
% -------------------------------------------------------------------------
function varargout = w_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSw=tf(NUM(2,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSw=tf(NUM(1,:),DEN);
end
 [gz,gp,gk]=zpkdata(SYSw);% Find TF gain in gk 
if gk<=0%Sets positive TF for Bode plot 
   ltiview('bode',-SYSw);
else
    ltiview('bode',SYSw);
end
% -------------------------------------------------------------------------
function varargout = q_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSq=tf(NUM(3,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSq=tf(NUM(2,:),DEN);
end
 [gz,gp,gk]=zpkdata(SYSq);
if gk<=0
   ltiview('bode',-SYSq);
else
    ltiview('bode',SYSq);
end
% -------------------------------------------------------------------------
function varargout = theta_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYStheta=tf(NUM(4,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYStheta=tf(NUM(3,:),DEN);
end
[gz,gp,gk]=zpkdata(SYStheta);
if gk<=0
   ltiview('bode',-SYStheta);
else
    ltiview('bode',SYStheta);
end
% -------------------------------------------------------------------------
function varargout = az_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSAz = tf(NUM(5,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSAz = tf(NUM(4,:),DEN);
end
[gz,gp,gk]=zpkdata(SYSAz);
if gk<=0
   ltiview('bode',-SYSAz);
else
    ltiview('bode',SYSAz);
end
% -------------------------------------------------------------------------
function varargout = a_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSalpha=tf(NUM(6,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSalpha=tf(NUM(5,:),DEN);
end
 [gz,gp,gk]=zpkdata(SYSalpha);
if gk<=0
   ltiview('bode',-SYSalpha);
else
    ltiview('bode',SYSalpha);
end
% -------------------------------------------------------------------------
function varargout = gamma_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSgamma=tf(NUM(7,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSgamma=tf(NUM(6,:),DEN);
end
 [gz,gp,gk]=zpkdata(SYSgamma);
if gk<=0
   ltiview('bode',-SYSgamma);
else
    ltiview('bode',SYSgamma);
end
% -------------------------------------------------------------------------
function varargout = h_lon_Callback(h, eventdata, handles, varargin)
switch get(handles.ModelOrder,'Value');;
case 1; %----- Full Order -------------------------------------------------
    [NUM,DEN] = Longsolve(handles);
    SYSdh=tf(NUM(8,:),DEN);
case 2 % ----- Reduced Order ---------------------------------------------- 
    [NUM,DEN] = ShortSolve(handles);
    SYSdh=tf(NUM(7,:),DEN);
end
 [gz,gp,gk]=zpkdata(SYSdh);
if gk<=0
   ltiview('bode',-SYSdh);
else
    ltiview('bode',SYSdh);
end
%----- LATERAL-DIRECTIONAL BODE PLOTS USING LTIVIEW -----------------------

function varargout = beta_ail_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSbetaA = tf(NUMA(1,:),DEN);
[gz,gp,gk]=zpkdata(SYSbetaA);
if gk<=0
   ltiview('bode',-SYSbetaA);
else
    ltiview('bode',SYSbetaA);
end
% -------------------------------------------------------------------------
function varargout = p_ail_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSpA = tf(NUMA(2,:),DEN);
[gz,gp,gk]=zpkdata(SYSpA);
if gk<=0
   ltiview('bode',-SYSpA);
else
    ltiview('bode',SYSpA);
end
% -------------------------------------------------------------------------
function varargout = r_ail_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSrA = tf(NUMA(3,:),DEN);
[gz,gp,gk]=zpkdata(SYSrA);
if gk<=0
   ltiview('bode',-SYSrA);
else
    ltiview('bode',SYSrA);
end
% ------------------------------------------------------------------------
function varargout = phi_ail_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSphiA = tf(NUMA(4,:),DEN);
[gz,gp,gk]=zpkdata(SYSphiA);
if gk<=0
   ltiview('bode',-SYSphiA);
else
    ltiview('bode',SYSphiA);
end
% -------------------------------------------------------------------------
function varargout = beta_r_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSbetaR = tf(NUMR(1,:),DEN);
[gz,gp,gk]=zpkdata(SYSbetaR);
if gk<=0
   ltiview('bode',-SYSbetaR);
else
    ltiview('bode',SYSbetaR);
end
% -------------------------------------------------------------------------
function varargout = p_r_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSpR = tf(NUMR(2,:),DEN);
[gz,gp,gk]=zpkdata(SYSpR);
if gk<=0
   ltiview('bode',-SYSpR);
else
   ltiview('bode',SYSpR);
end
% -------------------------------------------------------------------------
function varargout = r_r_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSrR = tf(NUMR(3,:),DEN);
[gz,gp,gk]=zpkdata(SYSrR);
if gk<=0
   ltiview('bode',-SYSrR);
else
    ltiview('bode',SYSrR);
end
% -------------------------------------------------------------------------
function varargout = phi_r_Callback(h, eventdata, handles, varargin)
[NUMA,NUMR,DEN] = latsolve(handles);
SYSphiR = tf(NUMR(4,:),DEN);
 [gz,gp,gk]=zpkdata(SYSphiR);
if gk<=0
   ltiview('bode',-SYSphiR);
else
    ltiview('bode',SYSphiR);
end
% =========== End of Bode plots ===========================================

% ========= OUTPUT RESPONSE TIME HISTORIES SELECTION ======================
% --- Select "Short Period" response time - 10s.
% --- Executes on button press in ShortTime.
function ShortTime_Callback(hObject, eventdata, handles)
set(handles.PlotTime,'string',num2str(10));

% --- Select "Long Period" response time - 100s.
% --- Executes on button press in LongTime.
function LongTime_Callback(hObject, eventdata, handles)
set(handles.PlotTime,'string',num2str(100));

% --- Executes on button press in plot_resp.
function plot_resp_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
        LongPlot(handles);   
    case 'lat'
        LatPlot(handles);    
end
% ========== End of response time histories plotting ======================

% === "RETURN TO OPENING SCREEN" BUTTON SELECTION ========================
% --- Executes on button press in pushbutton83.
function pushbutton83_Callback(hObject, eventdata, handles)
set(handles.pushbutton83,'visible','off')
set(handles.ModelOrder,'visible','off')
set(handles.fullord_lat,'visible','off')
set(handles.DerivativeFormat,'visible','off')
set(handles.ac_axes,'visible','off')
set(handles.inputsignal,'visible','off')
set(handles.model_menu,'visible','off')
set(handles.closedown,'visible','off')
set(handles.image,'visible','on')
set(handles.init_long,'visible','on')
set(handles.init_lat,'visible','on')
set(handles.abt,'visible','on')
set(handles.oug,'visible','on')
Units(handles,'off');
% ==== End of "Return to Opening Screen" ==================================

% ==== HELP MENU FUNCTIONS ================================================
% ==== NOTE: "Path" will need changing to suit computer set up.
% --- Executes on button press in "Open User Guide". 
function oug_Callback(hObject, eventdata, handles)
winopen('G:\FDA-CAD\FDA-CAD v3.0 - User Guide.pdf')

% --- Calls "About FDA-CAD" document from Opening screen button -----------
function abt_Callback(hObject, eventdata, handles)
winopen('G:\FDA-CAD\About FDA-CAD.pdf')

% --- Calls "User Guide" document from Help toolbar ----------------------- 
function about_menu_Callback(hObject, eventdata, handles)
winopen('G:\FDA-CAD\FDA-CAD v3.0 - User Guide.pdf')
% ==== End of Help tools ==================================================

% ==== LOAD AIRCRAFT DATA FROM FILE USING TOOL BAR "MODEL" BUTTON ========== 
function load_menu_Callback(hObject, eventdata, handles)
pathstring = get(handles.filename,'Userdata');
[fname,pname] = uigetfile(strcat(pathstring,'*.mat'),'Select the Mat-file');
if pname ~= 0
    set(handles.filename,'Userdata',pname);
end
if fname ~=0

A = importdata(strcat(pname,fname));  % loads aircraft data from file

seta(A,handles);            % loads aircraft data to GUI  
switch length(A)
case 30                     % Lateral/Directional data file selected
    set(handles.mode,'string','lat');
    set(handles.fullord_lat,'visible','on','enable','inactive');
    set(handles.ModelOrder,'visible','off');
    Modechange(handles);
    [fig flag]=figflag(1);
    if fig == 1
        close (flag)
    end
case 28                     % Longitudinal data file selected
    set(handles.mode,'string','long');
    set(handles.fullord_lat,'visible','off','enable','off');
    set(handles.ModelOrder,'visible','on');
    Modechange(handles);
    %ResetControl(handles);
    [fig flag]=figflag(1);
    if fig == 1
        close (flag)
    end
end
set(handles.filename,'string',fname);
else
end
% ==== End of model data load function ====================================

% ==== SAVE AIRCRAFT DATA TO FILE USING TOOL BAR "MODEL" BUTTON =========== 
function [newfile,newpath]=save_menu_Callback(hObject, eventdata, handles)
A = geta(handles);
pathstring = get(handles.filename,'Userdata');
if length(get(handles.filename,'String')) > 0
    filenamestring = get(handles.filename,'String');
else
    filenamestring = '*.mat';
end
[newfile,newpath] = uiputfile(strcat(pathstring,filenamestring),'Save file as:');
if newpath ~= 0
    set(handles.filename,'Userdata',newpath);
end
if newfile ~= 0;
    set(handles.filename,'string',newfile);
    save (strcat(newpath,newfile), 'A') 
end;


function result=savequestion(hObject, eventdata, handles)
result='ok';
if size(get(handles.Wn,'string'))>0
    closeans=questdlg('Do you wish to save model data?', ...
                        'Save or Continue?', ...
                        'Save','No','Cancel','Cancel');
    switch closeans
        case 'Save'
            [filename,pathname]=save_menu_Callback(hObject, eventdata, handles);
            if isequal(filename,0) | isequal(pathname,0) % cancel pressed
                result = 'cancel';
            end
        case 'No'
            result = 'ok';
        case 'Cancel'
            result = 'cancel';
    end
end
% ===== End of "Save model data" function =================================

% ==== RESPONSE TO "CLOSE REQUEST" FROM TOOLBAR ===========================
function CloseReq_Callback(hObject, eventdata, handles)
if strcmp(get(handles.Wn,'string'),'')
    closeans=questdlg('Do you really want to exit?',...
                      'Exit or Continue?',...
                      'Exit','Cancel','Exit');
    switch closeans
        case 'Exit'
            if isappdata(0,'ATRANS') 
            rmappdata(0,'ATRANS')
            elseif isappdata(0,'BACKSCREEN')
            rmappdata(0,'BACKSCREEN')
            end
            closereq
        case 'Cancel'
             return
    end
else
    result=savequestion(hObject, eventdata, handles);
    if strcmp(result,'ok')
            if isappdata(0,'ATRANS') 
            rmappdata(0,'ATRANS')
            elseif isappdata(0,'BACKSCREEN')
            rmappdata(0,'BACKSCREEN')
            end
        closereq
    else
    end
end
% ==== End of close request ===============================================

% ====== DERIVATIVE CONVERSION SUBGROUP FUNCTIONS =========================
function conv_dimal_Callback(hObject, eventdata, handles)
set(handles.conv_norm,'value',0)
set(handles.conv_dimless,'value',0)

function conv_norm_Callback(hObject, eventdata, handles)
set(handles.conv_dimal,'value',0)
set(handles.conv_dimless,'value',0)

function conv_dimless_Callback(hObject, eventdata, handles)
set(handles.conv_norm,'value',0)
set(handles.conv_dimal,'value',0)

function conv_w_Callback(hObject, eventdata, handles)
set(handles.conv_b,'value',0)

function conv_b_Callback(hObject, eventdata, handles)
set(handles.conv_w,'value',0)

function conv_cancel_Callback(hObject, eventdata, handles)
H=get(gcf,'children');
for i=1:length(H);
    userdata=get(H(i),'userdata');
    if length(userdata)==7;
        set(H(i),'visible','off');
    elseif length(userdata)<=6
        set(H(i),'enable','on');
    end
end

function conv_proceed_Callback(hObject, eventdata, handles)
A=geta(handles);
if isnan(A)
     %set(fdacad,'Pointer','custom');
     errordlg('Aircraft data is incomplete or invalid.','Invalid Data','modal'),        
     clc
     return
else
        
H=get(gcf,'children');
for i=1:length(H);
    userdata=get(H(i),'userdata');
    if length(userdata)==7;
        set(H(i),'visible','off');
    elseif length(userdata)<=6
        set(H(i),'enable','on');
    end
end

if get(handles.conv_dimal,'value')==1;
    form=1;
elseif get(handles.conv_norm,'value')==1;
    form=2;
elseif get(handles.conv_dimless,'value')==1;
    form=3;
else
    form=0;
    msgbox(sprintf('Please choose both a derivative format and axes notation\nor hit cancel to abort derivative conversion.'),...
           'Error','Error','modal');
end

if get(handles.conv_w,'value')==1
    ax=1;
elseif get(handles.conv_b,'value')==1;
    ax=2;
else 
    ax=0;
    msgbox(sprintf('Please choose both a derivative format and axes notation\nor hit cancel to abort derivative conversion.'),...
           'Error','Error','modal');
end
[Aconv]=perform_conversion(handles,form,ax);
DerivReport(handles,Aconv,form,ax);
end

function DerivativeFormat_Callback(h, eventdata, handles, varargin)
Units(handles,'on')
%======= End of Derivative Conversion Subgroup ============================

% == SWITCHES INPUT SIGNAL MAGNITUDE BETWEEN 1 rad and 1 deg (0.0175 rad)==
% --- Executes on button press in Amp.
function Amp_Callback(hObject, eventdata, handles)
if str2double(get(handles.amplitude,'string'))==1
    set(handles.amplitude,'string',num2str(0.0175))% MVC
else
    set(handles.amplitude,'string',num2str(1))
end
% ===== End of input signal magnitued switch function =====================

% ===== EXPORT TO WORKSPACE BUTTON ========================================
% --- Executes on button press in expws.
function expws_Callback(hObject, eventdata, handles)
export2workspace(handles)
% ===== End of ============================================================

% ==== PRINT REPORT BUTTON ================================================ 
% --- Executes on button press in printreport.
function printreport_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
        getappdata(0,'mo')
        LongReport(handles)
    case 'lat'
        Latreport(handles)
end
% ==== End of Print Report ================================================

%============= GO TO STABILITY AUGMENTATION SCREEN=========================
% --- Executes on button press in stab_cont.
function stab_cont_Callback(hObject, eventdata, handles)
result=savequestion(hObject, eventdata, handles);

if ~strcmp(result,'cancel')
%set(fdacad3,'pointer','watch');
ATRANSFER=geta(handles);
switch get(handles.mode,'string')%Sets correct TF's for stab_aug calculations
    case 'long'
 if ATRANSFER(27)==1
ATRANS=ATRANSFER;
elseif ATRANSFER(27)== 2
ATRANS=norm2dal(ATRANSFER);
elseif ATRANSFER(27)==3
ATRANS=dless2dal(ATRANSFER);
end
   case 'lat'
if ATRANSFER(29)==1
ATRANS=ATRANSFER;
elseif ATRANSFER(29)== 2
ATRANS=norm2dal(ATRANSFER);
elseif ATRANSFER(29)==3
ATRANS=dless2dal(ATRANSFER);
end    
end
setappdata(0,'ATRANS',ATRANS);% Stores current data.
setappdata(0,'MODE',get(handles.mode,'string'));
setappdata(0,'FILENAME',get(handles.filename,'string'));

stab_aug

else
end
% ==== Transfer to Stability Augmentation screen ==========================

% ======== "CLOSE FDA-CAD" RED BUTTON PRESS. ==============================
% Exits FDA-CAD completely.
function closedown_Callback(hObject, eventdata, handles)
closeans=questdlg('Do you really want to exit?',...
                      'Exit or Continue?',...
                      'Exit','Cancel','Exit');
switch closeans
case 'Exit'
   if isappdata(0,'ATRANS')
      rmappdata(0,'ATRANS')
   end
   if isappdata(0,'BACKSCREEN')
      rmappdata(0,'BACKSCREEN')
   end
   delete(fdacad3)
   closereq
case 'Cancel'
   return
end
% ====================== END OF FDA-CAD VERSION 3.01 ======================








































