function linemove(state,handles)

% This function is used inside NeilSmith.m to highlight, move,
% place and continously measure the position of the pitch attitude
% line in the Nichols plot.
% By Konstantinos Siliverdis 20-Aug-2004 

tem=getappdata(0,'TEM');

xdatainit=tem{1};
ydatainit=tem{2};
xdatainitp=tem{3};
ydatainitp=tem{4};

global initpos 

if length(findobj(gcf,'type','text','tag','postext'))==0
htext1=text(min(xlim)+150,max(ylim)+1.5,' ');
htext2=text(min(xlim)+65,max(ylim)+1.5,' ');
else
    htext=findobj(gcf,'type','text','tag','postext');
    htext1=htext(1);
    htext2=htext(2);
end
curobj=get(gcf,'currentobject');
curobj_tag=get(curobj,'tag');

if strcmp(state,'click')
    if strcmp(curobj_tag,'plottomove')
        set(curobj,'selected','on')
        initpos=get(gca,'currentpoint');
        if ~isappdata(curobj,'INITP')
            setappdata(curobj,'INITP',initpos);
        else
        end
        set(htext1,'string',num2str(initpos(1,1)),'tag','postext');
        set(htext2,'string',num2str(initpos(1,2)),'tag','postext');
        set(gcf,'windowbuttonmotionfcn','linemove(''move'')');
    else
    end
    
elseif strcmp(state,'release')
    if strcmp(curobj_tag,'plottomove')
        set(findobj(gcf,'tag','plottomove'),'selected','off');
        finpos=get(gca,'currentpoint');
        set(gcf,'windowbuttonmotionfcn',' ');
    else
    end
    
elseif strcmp(state,'move')
    hinit=findobj(gcf,'tag','plottomove');
    intermpos=get(gca,'currentpoint');
    difer=intermpos-getappdata(curobj,'INITP');
    xnew=xdatainit+difer(1,1); % Plot coordinates
    ynew=ydatainit+difer(1,2);
    xnewp=xdatainitp+difer(1,1);% 3.5 dB point coordinates
    ynewp=ydatainitp+difer(1,2);
    set(hinit(1),'xdata',xnewp,'ydata',ynewp);
    set(hinit(2),'xdata',xnew,'ydata',ynew);
    set(gca,'xlim',[-270 0],'ylim',[-16 24]);
    set(htext1,'string',num2str(difer(1,1)),'fontsize',10,'fontweight','normal','backgroundcolor',[0.925 0.914 0.847]);
    set(htext2,'string',num2str(difer(1,2)),'fontsize',10,'fontweight','normal','backgroundcolor',[0.925 0.914 0.847]);
end


