function Andal=norm2dal(A)

% Normalised to Dimensional derivative conversion
% By Konstantinos Siliverdis 20-Aug-2004
% Corrected by M V Cook February 2013

%A=geta(handles);

if length(A)==28 %longitudinal
    
Andal(1:11)=A(1:11);
Andal(27:28)=A(27:28);
Andal(12)=A(12)*A(6);   % Xu  * m
Andal(13)=A(13)*A(6);   % Xw  * m
Andal(14)=A(14)*A(6);   % Xdw * m
Andal(15)=A(15)*A(6);   % Xq  * m
Andal(16)=A(16)*A(6);   % Xde * m
Andal(17)=A(17)*A(6);   % Zu  * m
Andal(18)=A(18)*A(6);   % Zw  * m
Andal(19)=A(19)*A(6);   % Zdw * m
Andal(20)=A(20)*A(6);   % Zq  * m
Andal(21)=A(21)*A(6);   % Zde * m
Andal(22)=A(22)*A(7);   % Mu  * Iy
Andal(23)=A(23)*A(7);   % Mw  * Iy
Andal(24)=A(24)*A(7);   % Mdw * Iy
Andal(25)=A(25)*A(7);   % Mq  * Iy
Andal(26)=A(26)*A(7);   % Mde * Iy

elseif length(A)==30 %Lateral
 
 
Andal(1:13)=A(1:13);
Andal(29:30)=A(29:30);
Andal(14)=A(14)*A(6);   % Ybeta * m
Andal(15)=A(15)*A(6);   % Yp *m
Andal(16)=A(16)*A(6);   % Yr *m
Andal(17)=A(17)*A(6)*A(5);   % Yda*m*V
Andal(18)=A(18)*A(6)*A(5);   % Ydr*m*V

Andal(19)=(A(19)*A(7)-A(24)*A(9))/A(5);   % ((L'beta*Ix)-(N'beta*Ixz))/V - MVC
Andal(20)=A(20)*A(7)-A(25)*A(9);          % (L'p*Ix)-(N'p*Ixz) - MVC
Andal(21)=A(21)*A(7)-A(26)*A(9);          % (L'r*Ix)-(N'r*Ixz) - MVC
Andal(22)=A(22)*A(7)-A(27)*A(9);          % (L'da*Ix)-(N'da*Ixz) - MVC
Andal(23)=A(23)*A(7)-A(28)*A(9);          % (L'dr*Ix)-(N'dr*Ixz) - MVC

Andal(24)=(A(24)*A(8)-A(19)*A(9))/A(5);   % ((N'beta*Iz)-(L'beta*Ixz))/V - MVC
Andal(25)=A(25)*A(8)-A(20)*A(9);          % (N'p*Iz)-(L'p*Ixz) - MVC
Andal(26)=A(26)*A(8)-A(21)*A(9);          % (N'r*Iz)-(L'r*Ixz) - MVC
Andal(27)=A(27)*A(8)-A(22)*A(9);          % (N'da*Iz)-(L'da*Ixz) - MVC
Andal(28)=A(28)*A(8)-A(23)*A(9);          % (N'dr*Iz)-(L'dr*Ixz) - MVC

else
    msgbox('Data is incomplete or invalid. Please check for empty fields','Error in input data','error','modal')
end
