function [Aconv]=perform_conversion(handles,form,ax)

% This routine performs conversion of the original 
% derivatives into any of the a,b formats:
% a:Dimensional, Dimensionless, Normalised
% b:Wind Axes, Body Axes
% By Konstantinos Siliverdis 20-Aug-2004 

A=geta(handles);

originalform=get(handles.DerivativeFormat,'value');
originalax=get(handles.ac_axes,'value');
%keyboard
if originalform==1 %Original Dimensional
    
    if originalax==1  %Original Wind
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Aconv=A;
            elseif ax==2 %Convert to Body
                Aconv=AxesConv(handles,A);
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Aconv=dal2norm(A);
            elseif ax==2 %Convert to Body
                Ainter=AxesConv(handles,A);
                Aconv=dal2norm(Ainter);
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Aconv=dal2dless(A);
            elseif ax==2 %Convert to Body
                Ainter=AxesConv(handles,A);
                Aconv=dal2dless(Ainter);
            end
        end
        
    elseif originalax==2 %Original Body
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Aconv=AxesConv(handles,A);
            elseif ax==2 %Convert to Body
                Aconv=A;
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Ainter=AxesConv(handles,A);
                Aconv=dal2norm(Ainter);
            elseif ax==2 %Convert to Body
                Aconv=dal2norm(A);
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Ainter=AxesConv(handles,A);
                Aconv=dal2dless(Ainter);
            elseif ax==2 %Convert to Body
                Aconv=dal2dless(A);
            end
        end
    end
    
elseif originalform==2 %Original Normalised
    
    if originalax==1 %Original Wind
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Aconv=norm2dal(A);
            elseif ax==2 %Convert to Body
                Aconv=AxesConv(handles,A);
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Aconv=A;
            elseif ax==2 %Convert to Body
                Ainterb=AxesConv(handles,A);
                Aconv=dal2norm(Ainterb);
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Ainter=norm2dal(A);
                Aconv=dal2dless(Ainter);
            elseif ax==2 %Convert to Body
                Ainterb=AxesConv(handles,A);
                Aconv=dal2dless(Ainterb);
            end
        end
        
    elseif originalax==2 %Original Body
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Ainter=norm2dal(A);
                Aconv=AxesConv(handles,Ainter);
            elseif ax==2 %Convert to Body
                Aconv=norm2dal(A);
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Ainterb=AxesConv(handles,A);
                Aconv=dal2norm(Ainterb);
            elseif ax==2 %Convert to Body
                Aconv=A;
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Ainterb=AxesConv(handles,A);
                Aconv=dal2dless(Ainterb);
            elseif ax==2 %Convert to Body
                Ainter=norm2dal(A);
                Aconv=dal2dless(Ainter);
            end
        end
    end
    
elseif originalform==3 %Original Dimensionless
    
    if originalax==1 %Original Wind
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Aconv=dless2dal(A);
            elseif ax==2 %Convert to Body
                Ainter=dless2dal(A);
                Aconv=AxesConv(handles,Ainter);
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Ainter=dless2dal(A);
                Aconv=dal2norm(Ainter);
            elseif ax==2 %Convert to Body
                Ainterb=AxesConv(handles,A);
                Aconv=dal2norm(Ainterb);
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Aconv=A;
            elseif ax==2 %Convert to Body
                interb=AxesConv(handles,A);
                Aconv=dal2dless(Ainterb);
            end
        end
    elseif originalax==2 %Original Body
        
        if form==1 %Convert to Dimensional
            if ax==1 %Convert to Wind
                Ainter=dless2dal(A);
                Aconv=AxesConv(handles,Ainter);
            elseif ax==2 %Convert to Body
                Aconv=dless2dal(A);
            end
            
        elseif form==2 %Convert to Normalised
            if ax==1 %Convert to Wind
                Ainterb=AxesConv(handles,A);
                Aconv=dal2norm(Ainterb);
            elseif ax==2 %Convert to Body
                Ainter=dless2dal(A);
                Aconv=dal2norm(Ainter);
            end
            
        elseif form==3 %Convert to Dimensionless
            if ax==1 %Convert to Wind
                Ainterb=AxesConv(handles,A);
                Aconv=dal2dless(Ainterb);
            elseif ax==2 %Convert to Body
                Aconv=A;
            end
        end
    end
end
               
            
            
          
            
        
                

