function varargout = stab_aug(varargin)
% STAB_AUG M-file for stab_aug.fig
%      STAB_AUG, by itself, creates a new STAB_AUG or raises the existing
%      singleton*.
%
%      H = STAB_AUG returns the handle to a new STAB_AUG or the handle to
%      the existing singleton*.
%
%      STAB_AUG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in STAB_AUG.M with the given input arguments.
%
%      STAB_AUG('Property','Value',...) creates a new STAB_AUG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before stab_aug_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to stab_aug_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help stab_aug

% Last Modified by GUIDE v2.5 28-Feb-2013 09:28:19
global numplot
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @stab_aug_OpeningFcn, ...
                   'gui_OutputFcn',  @stab_aug_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% === Executes just before stability augmentation screen is made visible.
function stab_aug_OpeningFcn(hObject, eventdata, handles, varargin)
%This function opens the Stability & Control Screen and sets default
%conditions and values brought in from the Basic Aircraft screen.
% Data is then stored in "Application Data"

handleslat= {handles.KphiA,handles.KrA,handles.KpA,handles.KbetaA,...
             handles.SISOKphiA,handles.SISOKrA,handles.SISOKpA,handles.SISOKbetaA,...
             handles.AactNUM,handles.AactDEN,...
             handles.latframe};
             
handlesdir= {handles.KphiR,handles.KrR,handles.KpR,handles.KbetaR,...
             handles.SISOKphiR,handles.SISOKrR,handles.SISOKpR,handles.SISOKbetaR,...
             handles.RactNUM,handles.RactDEN,...
             handles.dirframe,handles.Kari,handles.Karitext,handles.Kariframe};
             
handleslong={handles.Ku,handles.Kw,handles.Kq,handles.Ktheta,...
             handles.SISOu,handles.SISOw,handles.SISOq,handles.SISOtheta,...
             handles.actNUM,handles.actDEN};
         
handlesailch=  {handles.beta_ail_ch,handles.p_ail_ch,handles.r_ail_ch,handles.phi_ail_ch};
handlesailplot={handles.beta_ail,handles.p_ail,handles.r_ail,handles.phi_ail};
handlesrch=    {handles.beta_r_ch,handles.p_r_ch,handles.r_r_ch,handles.phi_r_ch};
handlesrplot=  {handles.beta_r,handles.p_r,handles.r_r,handles.phi_r};
 
setappdata(handles.latordir,'HANDLESLAT',handleslat);
setappdata(handles.latordir,'HANDLESDIR',handlesdir);
setappdata(handles.latordir,'HANDLESLONG',handleslong);
setappdata(handles.latordir,'HANDLESAILCH',handlesailch);
setappdata(handles.latordir,'HANDLESAILPLOT',handlesailplot);
setappdata(handles.latordir,'HANDLESRCH',handlesrch);
setappdata(handles.latordir,'HANDLESRPLOT',handlesrplot);


% ==== End of data assembly process =======================================

% === GET BASIC AIRCRAFT MODEL DATA =======================================
%mo=getappdata(0,'mo'); %MVC - sets Longitudinal model order same as
% basic aircraft - normally full order. Currently not used in Stab-Aug.

set(handles.mode,'string',getappdata(0,'MODE'))% This returns "long" or "lat"
switch get(handles.mode,'string')
    case 'long'
                [NUM,DEN,A,B,C,D,Wn,z,Bbas] = Longsolve (handles);
        setappdata(handles.mode,'DATA',{NUM,DEN,A,B,C,D,Wn,z});
       
    case 'lat'
        set(handles.latordir,'visible','on')% MVC - this one seems to be important 
        [NUMA, NUMR, DEN, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
        setappdata(handles.mode,'DATA',{NUMA,NUMR,DEN,A,B,C,D,Wn,z});
        %set(handles.hand_qual,'enable','off') MVC
end
set(handles.Wn,'string',Wn);% Basic aircraft mode frequencies
set(handles.Z,'string',z); % Basic aircraft mode damping ratios
%==== End of model data import process ====================================

% ==== MODE CHANGE ROUTINE ================================================
% Determines LON or LAT screen object settings.
% Does not work correctly if sub-routine is called as it refers to the
% wrong screen data (fdacad3). Following replaces sub-routine and calls the
% correct figure. MVC
H = get(handles.figure2,'Children');
Mode = get(handles.mode,'string');
for i = 1:length(H);
    Userdata = get(H(i), 'Userdata');
    if length(Userdata) == 3;
        switch Mode 
            case 'lat'
                switch Userdata;
                case 'LAT'
                    set(H(i), 'Visible', 'On')
                case 'LON'
                    set(H(i), 'Visible', 'Off')
                end
            case 'long'
                        switch Userdata;
                case 'LAT'
                    set(H(i), 'Visible', 'Off')
                case 'LON'
                    set(H(i), 'Visible', 'On')
                    set(handles.text13,'visible','on')% Fix for a corrupted object. MVC 
                end
        end
    end
%set(handles.filename,'String','');            
end
% ===== End of mode change ======

% ==== SET UP SCREEN FOR LATERAL OR DIRECTIONAL ANALYSIS ==================
% This section sets up the LAT screen objects for lateral or directional
% analysis as selectd from drop down menu.
switch get(handles.mode,'string')
    case 'lat'
        switch get(handles.latordir,'value')
            case 1 %Lateral Analysis
                for i=1:length(handleslat)
                    set(handleslat{i},'visible','on');
                end
                for i=1:length(handlesdir)
                   set(handlesdir{i},'visible','off');
                end
                for i=1:length(handleslong)
                  set(handleslong{i},'visible','off');
                end
                for i=1:length(handlesrch)
                    set(handlesrch{i},'value',0,'enable','off');
                end
                for i=1:length(handlesrplot)
                    set(handlesrplot{i},'enable','off');
                end
               
           case 2 %Directional Analysis
               for i=1:length(handleslat)
                   set(handleslat{i},'visible','off');
               end
               for i=1:length(handlesdir)
                  set(handlesdir{i},'visible','on');
               end
               for i=1:length(handleslong)
                 set(handleslong{i},'visible','off');
               end
               for i=1:length(handlesailch)
                    set(handlesailch{i},'value',0,'enable','off');
               end
               for i=1:length(handlesailplot)
                   set(handlesailplot{i},'enable','off');
               end
       end
end              
%format %Not rqd, default should be OK MVC

% ==== INPUT SIGNAL SCREEN BOX SET UP =====================================
set(handles.pushbutton41,'position',[0.001 0.771 0.114 0.152]);
set(handles.widthlable,'Visible','off')
set(handles.width,'Visible','off')
set(handles.omegalable,'Visible','off')
set(handles.omega,'Visible','off')
% --- End of input signal stuff -------------------------------------------

% ==== SETS LATERAL OR DIRECTIONAL SCREEN FRAME ===========================
set(handles.filename,'string',getappdata(0,'FILENAME'));
set(handles.latframe,'visible','on');
set(handles.dirframe,'visible','off');
if strcmp(get(handles.latordir,'visible'),'off')
    set(handles.Kari,'visible','off')
    set(handles.Kariframe,'visible','off')
    set(handles.Karitext,'visible','off')
end

% ==== SOME GENERAL COMMANDS ==============================================
% Choose default command line output for stab_aug
handles.output = hObject;
% Update handles structure

% Not sure what this does
guidata(hObject, handles);
% UIWAIT makes stab_aug wait for user response (see UIRESUME)
% uiwait(handles.figure2);

movegui(handles.figure2,'north')% MVC addition to place image correctly on 
%screen - does not work properly earlier in the code listing.

% --- Outputs from this function are returned to the command line.
function varargout = stab_aug_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;
% ---- End of general stuff -----------------------------------------------

% ==== ERROR MESSAGES FOR INPUT DATA FUNCTIONS ============================
% This routine is called by all the objects that require a valid input
function varargout = valid_Callback(h, eventdata, handles, varargin)
val = str2double(get(h,'string'));
if isnan(val)
    errordlg('You must enter a numeric value','Invalid Input','modal')
else
    set(h, 'value', val) 
end

% Error message for higher order actuator numerators and invalid data
function actnum_restrict(h, eventdata, handles, varargin)
if length(str2num(get(h,'string')))>1
    set(h,'string',num2str(1))
    msgbox('Enter actuator gain only.','Error','modal')
end
if isnan(str2double(get(h,'string')))
    set(h,'string',num2str(1))
    errordlg('You must enter a numeric value','Invalid Input','modal') 
end
% Error message for higher than 2nd order actuator denominator and invalid data
function actden_restrict(h, eventdata, handles, varargin)
if length(str2num(get(h,'string')))>3
    set(h,'string',num2str(1))
    msgbox('Enter first or second order denominator only.','Error','modal')
end
if length(str2num(get(h,'string')))<1
    set(h,'string',num2str(1))
    errordlg('You must enter a numeric value','Invalid Input','modal')
end
% ---- End of error messages ----------------------------------------------

% ==== INPUT SIGNAL SELECTION  ============================================
function inputsignal_Callback(hObject, eventdata, handles)

switch get(handles.inputsignal,'Value')
    case 1  % Step
        set(handles.pushbutton41,'position',[0.001 0.771 0.114 0.152]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 2  % Impulse
        set(handles.pushbutton41,'position',[0.001 0.771 0.114 0.152]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 3  % Pulse
        set(handles.pushbutton41,'position',[0.001 0.732 0.114 0.189]);
        set(handles.widthlable,'Visible','on')
        set(handles.width,'Visible','on')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 4  % Ramp
        set(handles.pushbutton41,'position',[0.001 0.771 0.114 0.152]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')
    case 5  % Sine wave
        set(handles.pushbutton41,'position',[0.001 0.732 0.114 0.189]);
        set(handles.widthlable,'Visible','off')
        set(handles.width,'Visible','off')
        set(handles.omegalable,'Visible','on')
        set(handles.omega,'Visible','on')
    case 6  % Doublet
        set(handles.pushbutton41,'position',[0.001 0.732 0.114 0.189]);
        set(handles.widthlable,'Visible','on')
        set(handles.width,'Visible','on')
        set(handles.omegalable,'Visible','off')
        set(handles.omega,'Visible','off')        
end

% --- Switches input magnitude between 1 rad and 1 deg (0.0175 rad)
function Amp_Callback(hObject, eventdata, handles)
if str2double(get(handles.amplitude,'string'))==1
    set(handles.amplitude,'string',num2str(0.0175))% MVC
else
    set(handles.amplitude,'string',num2str(1))
end
% ==== End of input signal selection ======================================

% ===== ON SCREEN LONGITUDINAL ROOT LOCUS PLOTS ===========================
% CARE WITH TF SIGNS - Set to plot positive TF - MVC
% --- Executes on button press in SISOu.
function numplot=SISOu_Callback(hObject, eventdata, handles)
global numplot
numplot=1;
[NUM,DEN] = Longsolve(handles);
SYSu=tf(NUM(1,:),DEN);
axes(handles.rlaxes);
[gz,gp,gk]=zpkdata(SYSu);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSu);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSu);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Axial Velocity feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])
%set(handles.plw,'visible','off')

% --- Executes on button press in SISOw.
function numplot=SISOw_Callback(hObject, eventdata, handles)
global numplot
numplot=2;
[NUM,DEN] = Longsolve(handles);
SYSw=tf(NUM(2,:),DEN);
axes(handles.rlaxes);
[gz,gp,gk]=zpkdata(SYSw);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSw);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSw);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Normal Velocity feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOq.
function numplot=SISOq_Callback(hObject, eventdata, handles)
global numplot
numplot=3;
[NUM,DEN] = Longsolve(handles);
SYSq=tf(NUM(3,:),DEN);
axes(handles.rlaxes);
[gz,gp,gk]=zpkdata(SYSq);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSq);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSq);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Pitch Rate feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOtheta.
function numplot=SISOtheta_Callback(hObject, eventdata, handles)
global numplot
numplot=4;
[NUM,DEN] = Longsolve(handles);
SYStheta=tf(NUM(4,:),DEN);
axes(handles.rlaxes);
[gz,gp,gk]=zpkdata(SYStheta);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYStheta);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYStheta);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Pitch Attitude feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])
%==========================================================================

% ===== ON SCREEN LATERAL ROOT LOCUS PLOTS ===========================
% CARE WITH TF SIGNS - MVC
% --- Executes on button press in SISOKbetaA.
function numplot=SISOKbetaA_Callback(hObject, eventdata, handles)
global numplot
numplot=5;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSbetaA = tf(NUMA(1,:),DENA);
[gz,gp,gk]=zpkdata(SYSbetaA);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSbetaA);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSbetaA);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Sideslip Angle feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKpA.
function numplot=SISOKpA_Callback(hObject, eventdata, handles)
global numplot
numplot=6;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSpA = tf(NUMA(2,:),DENA);
[gz,gp,gk]=zpkdata(SYSpA);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSpA);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSpA);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Roll Rate feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKrA.
function numplot=SISOKrA_Callback(hObject, eventdata, handles)
global numplot
numplot=7;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSrA = tf(NUMA(3,:),DENA);
[gz,gp,gk]=zpkdata(SYSrA);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSrA);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSrA);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Yaw Rate feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKphiA.
function numplot=SISOKphiA_Callback(hObject, eventdata, handles)
global numplot
numplot=8;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSphiA = tf(NUMA(4,:),DENA);
[gz,gp,gk]=zpkdata(SYSphiA);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSphiA);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSphiA);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Roll Attitude feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])
%==========================================================================

% ===== ON SCREEN DIRECTIONAL ROOT LOCUS PLOTS ============================
% CARE WITH TF SIGNS - MVC
% --- Executes on button press in SISOKbetaR.
function numplot=SISOKbetaR_Callback(hObject, eventdata, handles)
global numplot
numplot=9;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSbetaR = tf(NUMR(1,:),DENA);
[gz,gp,gk]=zpkdata(SYSbetaR);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSbetaR);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSbetaR);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Sideslip Angle feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKpR.
function numplot=SISOKpR_Callback(hObject, eventdata, handles)
global numplot
numplot=10;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSpR = tf(NUMR(2,:),DENA);
[gz,gp,gk]=zpkdata(SYSpR);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSpR);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSpR);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Roll Rate feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKrR.
function numplot=SISOKrR_Callback(hObject, eventdata, handles)
global numplot
numplot=11;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSrR = tf(NUMR(3,:),DENA);
[gz,gp,gk]=zpkdata(SYSrR);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSrR);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSrR);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Yaw Rate feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% --- Executes on button press in SISOKphiR.
function numplot=SISOKphiR_Callback(hObject, eventdata, handles)
global numplot
numplot=12;
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSphiR = tf(NUMR(4,:),DENA);
[gz,gp,gk]=zpkdata(SYSphiR);% Find TF gain in gk -MVC
if gk<=0 %If TF negative, changes sign for root locus - MVC
    rlocus(-SYSphiR);
    set(handles.neggain,'visible','on')
    set(handles.posgain,'visible','off')
else
    rlocus(SYSphiR);
    set(handles.posgain,'visible','on')
    set(handles.neggain,'visible','off')
end
sgrid,title('Roll Attitude feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

%============== END of Root Locus Plots ===================================

% ============= ACTUATOR BODE PLOT ========================================
function SISOact_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
        actNUM=str2num(get(handles.actNUM,'string'));
        actDEN=str2num(get(handles.actDEN,'string'));
    case 'lat'
        switch get(handles.latordir,'value')
            case 1
                actNUM=str2num(get(handles.AactNUM,'string'));
                actDEN=str2num(get(handles.AactDEN,'string'));
            case 2
                actNUM=str2num(get(handles.actNUM,'string'));
                actDEN=str2num(get(handles.actDEN,'string'));
        end
end
SYSact=tf(actNUM,actDEN);
ltiview('bode',-SYSact);
% ---- End of actuator Bode plot ------------------------------------------



% ============ OUTPUT VARIABLE BODE PLOTS =================================
% ---- LONGITUDINAL BODE PLOTS USING LTIVIEW IN RESERVED SCREEN WINDOW ----
% NOTE:- Negative transfer functions set to positive for Bode plots.
% Non-Minimum phase TF's will give non-zero phase at zero frequency
function varargout = u_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSu = tf(NUM(1,:),DEN);
    [gz,gp,gk]=zpkdata(SYSu);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSu);
else
    ltiview('bode',SYSu);
end

% -------------------------------------------------------------------------
function varargout = w_lon_Callback(h, eventdata, handles, varargin)

    [NUM,DEN] = Longsolve(handles);
    SYSw=tf(NUM(2,:),DEN);
    [gz,gp,gk]=zpkdata(SYSw);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSw);
else
    ltiview('bode',SYSw);
end
% -------------------------------------------------------------------------
function varargout = q_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSq=tf(NUM(3,:),DEN);
    [gz,gp,gk]=zpkdata(SYSq);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSq);
else
    ltiview('bode',SYSq);
end
% -------------------------------------------------------------------------
function varargout = theta_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYStheta=tf(NUM(4,:),DEN);
    [gz,gp,gk]=zpkdata(SYStheta);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYStheta);
else
    ltiview('bode',SYStheta);
end
% -------------------------------------------------------------------------
function varargout = az_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSAz = tf(NUM(5,:),DEN);
    [gz,gp,gk]=zpkdata(SYSAz);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSAz);
else
    ltiview('bode',SYSAz);
end
% -------------------------------------------------------------------------
function varargout = a_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSalpha=tf(NUM(6,:),DEN);
    [gz,gp,gk]=zpkdata(SYSalpha);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSalpha);
else
    ltiview('bode',SYSalpha);
end
% -------------------------------------------------------------------------
function varargout = gamma_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSgamma=tf(NUM(7,:),DEN);
    [gz,gp,gk]=zpkdata(SYSgamma);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSgamma);
else
    ltiview('bode',SYSgamma);
end
% -------------------------------------------------------------------------
function varargout = h_lon_Callback(h, eventdata, handles, varargin)
    [NUM,DEN] = Longsolve(handles);
    SYSdh=tf(NUM(8,:),DEN);
    [gz,gp,gk]=zpkdata(SYSdh);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSdh);
else
    ltiview('bode',SYSdh);
end


% ==== LATERAL-DIRECTIONAL BODE PLOTS USING LTIVIEW (TF signs!)============

function varargout = beta_ail_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSbetaA = tf(NUMA(1,:),DEN);
    [gz,gp,gk]=zpkdata(SYSbetaA);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for Bode plot - MVC
   ltiview('bode',-SYSbetaA);
else
    ltiview('bode',SYSbetaA);
end
% -------------------------------------------------------------------------
function varargout = p_ail_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSpA = tf(NUMA(2,:),DEN);
    [gz,gp,gk]=zpkdata(SYSpA);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSpA);
else
    ltiview('bode',SYSpA);
end
% -------------------------------------------------------------------------
function varargout = r_ail_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSrA = tf(NUMA(3,:),DEN);
    [gz,gp,gk]=zpkdata(SYSrA);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSrA);
else
    ltiview('bode',SYSrA);
end
% ------------------------------------------------------------------------
function varargout = phi_ail_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSphiA = tf(NUMA(4,:),DEN);
    [gz,gp,gk]=zpkdata(SYSphiA);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSphiA);
else
    ltiview('bode',SYSphiA);
end
% -------------------------------------------------------------------------
function varargout = beta_r_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSbetaR = tf(NUMR(1,:),DEN);
    [gz,gp,gk]=zpkdata(SYSbetaR);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSbetaR);
else
    ltiview('bode',SYSbetaR);
end
% -------------------------------------------------------------------------
function varargout = p_r_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSpR = tf(NUMR(2,:),DEN);
    [gz,gp,gk]=zpkdata(SYSpR);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSpR);
else
   ltiview('bode',SYSpR);
end
% -------------------------------------------------------------------------
function varargout = r_r_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSrR = tf(NUMR(3,:),DEN);
    [gz,gp,gk]=zpkdata(SYSrR);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSrR);
else
    ltiview('bode',SYSrR);
end
% -------------------------------------------------------------------------
function varargout = phi_r_Callback(h, eventdata, handles, varargin)
    [NUMA,NUMR,DEN] = latsolve(handles);
    SYSphiR = tf(NUMR(4,:),DEN);
    [gz,gp,gk]=zpkdata(SYSphiR);% Find TF gain in gk -MVC
if gk<=0%Sets positive TF for Bode plot - MVC
   ltiview('bode',-SYSphiR);
else
    ltiview('bode',SYSphiR);
end
% ================ End of Bode Plots ======================================

% ==== "RUN MODEL" BUTTON. ================================================
function run_model_Callback(hObject, eventdata, handles)
%set(handles.Wn,'enable','on')
%set(handles.Z,'enable','on')
switch get(handles.mode,'string')
    case 'long'
        [NUM,DEN] = Longsolve(handles);
    case 'lat'
        [NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
        return
end
% ==========End of run model ==============================================

% ================== RESPONSE PLOTTING FUNCTIONS ==========================
% --- Executes on "Short Period" button press.
function ShortTime_Callback(hObject, eventdata, handles)
set(handles.PlotTime,'string',num2str(10));

% --- Executes on "Long Period" button press.
function LongTime_Callback(hObject, eventdata, handles)
set(handles.PlotTime,'string',num2str(100));

% --- Executes on button press in plot_resp.
function plot_resp_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
    LongPlot(handles);    
    case 'lat'
    LatPlot(handles);    
end

% --- Executes on button press in SavePlot1.
function SavePlot1_Callback(hObject, eventdata, handles)
SavePlot1(handles)


% --- Executes on button press in SavePlot2.
function SavePlot2_Callback(hObject, eventdata, handles)
SavePlot2(handles)

% --- Executes on button press in ComparePlot.
function ComparePlot_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
        CompareLongPlot(handles)
    case 'lat'
        CompareLatPlot(handles)
end
% ================= End of Plotting Functions =============================

% ================= POLE PLACEMENT FUNCTIONS ============================== 
% ------ Longitudinal -----------------------------------------------------
function LongPolePlacement_Callback(hObject, eventdata, handles)
[A,B] = Longpolesolve (handles);
%-------Lateral-Directional -----------------------------------------------
function LatPolePlacement_Callback(hObject, eventdata, handles)
[A, B]=LatPolesolve(handles);
% ================= End of Pole Placement Functions =======================

% ================== LATERAL OR DIRECTIONAL ANALYSIS SELECTION ============
function latordir_Callback(hObject, eventdata, handles)
%This section working correctly MVC

handleslat=getappdata(handles.latordir,'HANDLESLAT');
handlesdir=getappdata(handles.latordir,'HANDLESDIR');
handleslong=getappdata(handles.latordir,'HANDLESLONG');
handlesailch=getappdata(handles.latordir,'HANDLESAILCH');
handlesailplot=getappdata(handles.latordir,'HANDLESAILPLOT');
handlesrch=getappdata(handles.latordir,'HANDLESRCH');
handlesrplot=getappdata(handles.latordir,'HANDLESRPLOT');

switch get(handles.latordir,'value')%get(hObject,'value')
        case 1 %Lateral Analysis
                for i=1:length(handleslat)
                    set(handleslat{i},'visible','on');
                end
                for i=1:length(handlesdir)
                   set(handlesdir{i},'visible','off');
                end
                for i=1:length(handleslong)
                  set(handleslong{i},'visible','off');
                end
                for i=1:length(handlesrch)
                    set(handlesrch{i},'value',0,'enable','off');
                    set(handlesailch{i},'value',1,'enable','on');
                end
                for i=1:length(handlesrplot)
                    set(handlesrplot{i},'enable','off');
                    set(handlesailplot{i},'enable','on');
                end
    case 2 %Directional Analysis
               for i=1:length(handleslat)
                   set(handleslat{i},'visible','off');
               end
               for i=1:length(handlesdir)
                  set(handlesdir{i},'visible','on');
               end
               for i=1:length(handleslong)
                 set(handleslong{i},'visible','off');
               end
               for i=1:length(handlesailch)
                    set(handlesailch{i},'value',0,'enable','off');
                    set(handlesrch{i},'value',1,'enable','on');
               end
               for i=1:length(handlesailplot)
                   set(handlesailplot{i},'enable','off');
                   set(handlesrplot{i},'enable','on');
               end
end
% ======== End of Lateral or Directional analysis selection ===============        

% ==== RETURN TO BASIC AIRCRAFT SCREEN BUTTON =============================
% Disabled until bug in lateral-directional return is corrected MVC

% --- Executes on button press in backbasic.
function backbasic_Callback(hObject, eventdata, handles)
set(handles.latordir,'visible','off')% MVC - 
delete(handles.rlaxes)
setappdata(0,'BACKSCREEN',1)
rmappdata(0,'ATRANS')
closereq
fdacad3
% ------ End of return to basic aircraft screen ---------------------------

% ======== "CLOSE FDA-CAD" RED BUTTON PRESS. ==================================
% Exits FDA-CAD completely. MVC
function closedown_Callback(hObject, eventdata, handles)
closeans=questdlg('Do you really want to exit?',...
                      'Exit or Continue?',...
                      'Exit','Cancel','Exit');
switch closeans
case 'Exit'
   if isappdata(0,'ATRANS')
      rmappdata(0,'ATRANS')
   end
   if isappdata(0,'BACKSCREEN')
      rmappdata(0,'BACKSCREEN')
   end
   delete(fdacad3)
   closereq
case 'Cancel'
   return
end
%==========================================================================

% ============= CLOSE STABILITY AUGMENTATION SCREEN REQUEST ===============
% ============= Various check messages before closing =====================
% ---- Tool bar close request - SHUTS DOWN FDA-CAD COMPLETELY ------------- 
function Close_Req(hObject, eventdata, handles)

closeans=questdlg('Do you really want to exit?',...
                      'Exit or Continue?',...
                      'Exit','Cancel','Exit');
switch closeans
case 'Exit'
   if isappdata(0,'ATRANS')
      rmappdata(0,'ATRANS')
   end
   if isappdata(0,'BACKSCREEN')
      rmappdata(0,'BACKSCREEN')
   end
   delete(figure2)
   delete(fdacad3)
   closereq
case 'Cancel'
   return
end
% ==============End of close request ======================================

% --- "EXPORT TO WORKSPACE" BUTTON ========================================
function expws_Callback(hObject, eventdata, handles)
export2workspace(handles);
% ===== End of export =====================================================


% --- Executes on button press in hand_qual. MVC this section
%function hand_qual_Callback(hObject, eventdata, handles)
%setappdata(0,'STATUS','PRESSED');
%[NUM,DEN,A,B,C,D,Wn,z,Bbas,Abas,Cbas,Dbas] = Longsolve (handles);
%acdyn={Abas,Bbas,Cbas,Dbas,...
       %get(handles.latordir,'value'),get(handles.mode,'string'),...
%       str2num(get(handles.actNUM,'string')),str2num(get(handles.actDEN,'string')),...
       %get(handles.Ku,'value'),get(handles.Kw, 'Value'),get(handles.Kq, 'Value'),get(handles.Ktheta, 'Value');
%setappdata(0,'ACDYN',acdyn);
%hand_qual

%set(stab_aug,'visible','off');
% =========================================================================

% ==== SHOW AIRCRAFT STATE EQUATION ON "BASIC AIRCRAFT" BUTTON PUSH =======
% ---- Referred to as Aircraft Dynamics by originator! --------------------

function acdyn_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    
    case 'long'
[NUM,DEN,A,B,C,D,Wn,z,Bbas,Abas,Cbas,Dbas] = Longsolve (handles);
acdyn={Abas,Bbas,Cbas,Dbas,...
       get(handles.latordir,'value'),get(handles.mode,'string'),...
       str2num(get(handles.actNUM,'string')),str2num(get(handles.actDEN,'string')),...
       get(handles.Ku,'value'),get(handles.Kw, 'Value'),get(handles.Kq, 'Value'),get(handles.Ktheta, 'Value')};

   case 'lat'
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas,Abas,Cbas,Dbas]=latsolve(handles);
acdyn={Abas,Bbas,Cbas,Dbas,...
       get(handles.latordir,'value'),get(handles.mode,'string'),...
       str2num(get(handles.AactNUM,'string')),str2num(get(handles.AactDEN,'string')),...
       str2num(get(handles.RactNUM,'string')),str2num(get(handles.RactDEN,'string')),...
       get(handles.KbetaA,'value'),get(handles.KpA, 'Value'),get(handles.KrA, 'Value'),get(handles.KphiA, 'Value'),...
       get(handles.KbetaR,'value'),get(handles.KpR, 'Value'),get(handles.KrR, 'Value'),get(handles.KphiR, 'Value')};
end
setappdata(0,'ACDYN',acdyn);
[fig flag]=figflag('Aircraft Dynamics');
if fig==1
    close ('Aircraft Dynamics')
end
ac_dynamics
% =========================================================================

% ==== "PRINT REPORT" BUTTON ==============================================
function Printrep_Callback(hObject, eventdata, handles)
switch get(handles.mode,'string')
    case 'long'
        LongReport( handles )
    case 'lat'
        Latreport(handles)
end

% ==== ROOT LOCUS PLOTS IN UNDOCKED FIGURE WINDOW =========================
% ---- TF signs dealt with as before MVC ----------------------------------
function undock_menu_Callback(hObject, eventdata, handles,numplot)
global numplot
figure(505);
set(505,'Name','Root Locus plot','numbertitle','off')
axes;
switch numplot
    
% ---- Longitudinal root locus --------------------------------------------
    case 1
[NUM,DEN] = Longsolve(handles);
SYSu=tf(NUM(1,:),DEN);
[gz,gp,gk]=zpkdata(SYSu);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSu);
else
    rlocus(SYSu);
end
sgrid,title('Axial Velocity feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

    case 2
[NUM,DEN] = Longsolve(handles);
SYSw=tf(NUM(2,:),DEN);
[gz,gp,gk]=zpkdata(SYSw);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSw);
else
    rlocus(SYSw);
end
sgrid,title('Normal Velocity feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

    case 3
[NUM,DEN] = Longsolve(handles);
SYSq=tf(NUM(3,:),DEN);
[gz,gp,gk]=zpkdata(SYSq);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSq);
else
    rlocus(SYSq);
end
sgrid,title('Pitch Rate feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

    case 4
[NUM,DEN] = Longsolve(handles);
SYSth=tf(NUM(4,:),DEN);
[gz,gp,gk]=zpkdata(SYSth);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSth);
else
    rlocus(SYSth);
end
sgrid,title('Pitch Attitude feedback to Elevator','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% ---- Lateral root locus -------------------------------------------------
	case 5
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSbetaA = tf(NUMA(1,:),DENA);
[gz,gp,gk]=zpkdata(SYSbetaA);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSbetaA);
else
    rlocus(SYSbetaA);
end
sgrid,title('Sideslip Angle feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 6
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSpA = tf(NUMA(2,:),DENA);
[gz,gp,gk]=zpkdata(SYSpA);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSpA);
else
    rlocus(SYSpA);
end
sgrid,title('Roll Rate feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 7
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSrA = tf(NUMA(3,:),DENA);
[gz,gp,gk]=zpkdata(SYSrA);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSrA);
else
    rlocus(SYSrA);
end;
sgrid,title('Yaw Rate feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 8
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSphiA = tf(NUMA(4,:),DENA);
[gz,gp,gk]=zpkdata(SYSphiA);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSphiA);
else
    rlocus(SYSphiA);
end
sgrid,title('Roll Attitude feedback to Aileron','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

% ---- Directional root locus ---------------------------------------------     
    case 9
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSbetaR = tf(NUMR(1,:),DENA);
[gz,gp,gk]=zpkdata(SYSbetaR);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSbetaR);
else
    rlocus(SYSbetaR);
end
sgrid,title('Sideslip Angle feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 10
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSpR = tf(NUMR(2,:),DENA);
[gz,gp,gk]=zpkdata(SYSpR);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSpR);
else
    rlocus(SYSpR);
end
sgrid,title('Roll Rate feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 11
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSrR = tf(NUMR(3,:),DENA);
[gz,gp,gk]=zpkdata(SYSrR);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSrR);
else
    rlocus(SYSrR);
end
sgrid,title('Yaw Rate feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

	case 12
[NUMA, NUMR, DENA, A,B,C,D,Wn,z,Bbas]=latsolve(handles);
SYSphiR = tf(NUMR(4,:),DENA);
[gz,gp,gk]=zpkdata(SYSphiR);% Find TF gain in gk -MVC
if gk<=0%If TF negative, changes sign for root locus - MVC
    rlocus(-SYSphiR);
else
    rlocus(SYSphiR);
end
sgrid,title('Roll Attitude feedback to Rudder','fontsize',10,'fontweight','bold')
ylim([-max(get(gca,'ylim'))/100 max(get(gca,'ylim'))])

end

% ============ End of Root Locus Figure Window Plots ======================





